﻿DeclareModule Main
  
  Declare Open()
  
  Global ProjectTitle.s
  Global TempFolder.s
  
EndDeclareModule

IncludeFile "dlgImageSel.pbi"


Module Main
  

Global DMGMain

Global btnSelectProject, strProjectFolder, txtProjectFolder, txtBackImage, btnSelCreat, strBackImage, strProjectTitle, txtxtProjectTitle, btnCreateImage, btnProceed

Global Event.i,Quit.i


Global ProjectFolder.s,BackImage.s,DMGPath.s

Procedure.i FileExists(fileName.s)
  ProcedureReturn Bool(FileSize(fileName) > -1)
EndProcedure

Procedure CopyAppAlias()
  
  NSFM = CocoaMessage(0, 0, "NSFileManager defaultManager")
  sourceFile.s = "/Users/williamatkin/Applications"
  destinationFile.s = "/Volumes/" + ProjectTitle + "/Applications"

  CocoaMessage(0, NSFM, "copyItemAtPath:$", @sourceFile, "toPath:$", @destinationFile, "error:", #nil)
  
EndProcedure

Procedure CopyUserApp(SourceFile.s)
  
  Debug SourceFile
  
  NSFM = CocoaMessage(0, 0, "NSFileManager defaultManager")
  ;sourceFile.s = "/Applications/OggvorbisCommentEditor.app"
  destinationFile.s = "/Volumes/" + ProjectTitle + "/" + ProjectTitle

  CocoaMessage(0, NSFM, "copyItemAtPath:$", @sourceFile, "toPath:$", @destinationFile, "error:", #nil)
  
EndProcedure

Procedure.s AppleScript(Script.s)
  Protected retVal.s, strVal, numItems, i
  Protected aScript = CocoaMessage(0, CocoaMessage(0, CocoaMessage(0, 0, "NSAppleScript alloc"), "initWithSource:$", @Script), "autorelease")
  Protected eventDesc = CocoaMessage(0, aScript, "executeAndReturnError:", #nil)
  If eventDesc
    numItems = CocoaMessage(0, eventDesc, "numberOfItems")
    If numItems
      For i = 1 To numItems
        strVal = CocoaMessage(0, CocoaMessage(0, eventDesc, "descriptorAtIndex:", i), "stringValue")
        If strVal
          retVal + PeekS(CocoaMessage(0, strVal, "UTF8String"), -1, #PB_UTF8)
          If i <> numItems : retVal + #LF$ : EndIf
        EndIf
      Next
    Else
      strVal = CocoaMessage(0, eventDesc, "stringValue")
      If strVal : retVal = PeekS(CocoaMessage(0, strVal, "UTF8String"), -1, #PB_UTF8) : EndIf
    EndIf
  EndIf
  
  Debug retVal
  
  ProcedureReturn retVal 
EndProcedure

Procedure CreateDMG()
  
  Define CreateDMG.s,MountDMG.s,SetProp.s,UnMount.s,ReadOnly.s  
  
  CreateDMG = "do shell script " + #DQUOTE$ + "hdiutil create -size 100m -fs HFS+ -volname <VolName> <VolNamePath>.dmg" + #DQUOTE$
  CreateDMG = ReplaceString(CreateDMG,"<VolName>",ProjectTitle)
  CreateDMG = ReplaceString(CreateDMG,"<VolNamePath>",DMGPath + "/" + ProjectTitle)

  Applescript(CreateDMG)
  
  MountDMG  = "do shell script " + #DQUOTE$ + "hdiutil mount " + DMGPath + "/" + ProjectTitle + ".dmg"  + #DQUOTE$

  Applescript(MountDMG)
  
  While WindowEvent():Wend
  
  
  ;Copy Image File
  CopyFile(TempFolder + "BackImage.png" ,"/Volumes/" + ProjectTitle + "/BackImage.png")
  
  ;Copy Applications Alias
  CopyAppAlias()
  
  ;Copy User App
  CopyUserApp(ProjectFolder)
  
  ;Set Properties
      If ReadFile(0, "SetProperties.txt")
      length = Lof(0)                            ; get the length of opened file
      *MemoryID = AllocateMemory(length)         ; allocate the needed memory
      If *MemoryID
        bytes = ReadData(0, *MemoryID, length)   ; read all data into the memory block
        Debug "Number of bytes read: " + Str(bytes)
        
        SetProp = PeekS(*MemoryID,bytes,#PB_UTF8)
        
        SetProp = ReplaceString(SetProp,"This_dmg", #DQUOTE$ + ProjectTitle + #DQUOTE$)
        SetProp = ReplaceString(SetProp,"<Project>", #DQUOTE$ + ProjectTitle + #DQUOTE$)
        
      EndIf
      CloseFile(0)
    EndIf
    
    Applescript(SetProp)
  
    ;Hide The BackImage File
    RenameFile("/Volumes/" + ProjectTitle + "/BackImage.png","/Volumes/" + ProjectTitle + "/.BackImage.png")
    
    While WindowEvent():Wend
    
    ;Unmount
    Unmount =  "do shell script " + #DQUOTE$ + "hdiutil detach /Volumes/" + ProjectTitle + #DQUOTE$
    
    Applescript(Unmount)
    
    
    ;Make Read Only 
    ReadOnly = "do shell script " + #DQUOTE$ + "hdiutil convert " + DMGPath + "/" + ProjectTitle + ".dmg" + " -format UDRO -o " + DMGPath + "/" + ProjectTitle + "Read.dmg" + #DQUOTE$

    Applescript(ReadOnly)
    
    ;Rename The DMG
    RenameFile(DMGPath + "/" + ProjectTitle + "Read.dmg" ,DMGPath + "/" + ProjectTitle + ".dmg") 

EndProcedure

  Procedure.i CheckAll()
    
    Protected AppFile.s,ImageFile.s
  
    ProjectTitle = GetGadgetText(strProjectTitle)
  
    If ProjectTitle = ""
      MessageRequester("Error","Must Have Project Title!",#PB_MessageRequester_Error|#PB_MessageRequester_Ok)
      ProcedureReturn #False
    EndIf
  
    ;No Spaces Allowed" 
    ProjectTitle = ReplaceString(ProjectTitle," ","")
    
    AppFile = GetGadgetText(strProjectFolder)
    
    ;check If exists
    If FileSize(AppFile) <>-2
      
      MessageRequester("Error","No Application Selected!",#PB_MessageRequester_Error|#PB_MessageRequester_Ok)
      ProcedureReturn #False
      
    EndIf
    
      ImageFile = GetGadgetText(strBackImage)
    
    ;check If exists
    If FileSize(TempFolder + ImageFile) < 1
      
      MessageRequester("Error","Need Back Image!",#PB_MessageRequester_Error|#PB_MessageRequester_Ok)
      ProcedureReturn #False
      
    EndIf  
    
    ProcedureReturn #True
    
EndProcedure

  Procedure Open()

    DMGMain = OpenWindow(#PB_Any, 0, 0, 440, 300, "DMG Creator", #PB_Window_SystemMenu)
    btnSelectProject = ButtonGadget(#PB_Any, 350, 110, 80, 25, "Select")
    strProjectFolder = StringGadget(#PB_Any, 10, 110, 330, 25, "Unk")
    txtProjectFolder = TextGadget(#PB_Any, 10, 80, 250, 20, "Project Folder")
    txtBackImage = TextGadget(#PB_Any, 10, 150, 250, 20, "Back Image")
    btnSelCreat = ButtonGadget(#PB_Any, 350, 180, 80, 25, "Sel/Create")
    strBackImage = StringGadget(#PB_Any, 10, 180, 330, 25, "Img")
    strProjectTitle = StringGadget(#PB_Any, 10, 40, 330, 25, "Title")
    txtxtProjectTitle = TextGadget(#PB_Any, 10, 10, 250, 20, "Project Title")
    btnCreateImage = ButtonGadget(#PB_Any, 10, 220, 80, 25, "Create")
  
    TempFolder = GetTemporaryDirectory()

    DMGPath = GetUserDirectory(#PB_Directory_Documents) + "DMGFiles"
  
    CreateDirectory(DMGPath)
  
    Repeat
      Event = WaitWindowEvent()
    
      If Event = #PB_Event_CloseWindow
        Quit = #True
        End
      EndIf
 
     Select Event
     
       Case #PB_Event_Gadget
         Select EventGadget()
             
           Case btnSelectProject
             
             ProjectFolder = OpenFileRequester("Select Application", "", "Apps (*.app)|*.app",0) 
                       
             If ProjectFolder
               SetGadgetText(strProjectFolder,ProjectFolder)
             EndIf
             
           Case btnSelCreat
             ProjectTitle = GetGadgetText(strProjectTitle)
             BackImage = ImgSelect::Open()
             If BackImage <> ""
               SetGadgetText(strBackImage,BackImage)
             EndIf
             
           Case btnCreateImage
 
             If CheckAll()
               CreateDMG()
             EndIf
             
         EndSelect
     
      EndSelect
     
    Until Quit = #True
  EndProcedure
 
 
EndModule




Main::Open()
; IDE Options = PureBasic 5.71 LTS (MacOS X - x64)
; CursorPosition = 168
; FirstLine = 116
; Folding = D-
; EnableXP
; Executable = /Applications/CreateDMG.app
; CompileSourceDirectory